VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLauncher"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const WindowsSystemLauncher As String = "Windows.System.Launcher"
Private Const IID_ILauncherStatics As String = "{277151c3-9e3e-42f6-91a4-5dfdeb232451}"
Private Const IID_ILauncherStatics2 As String = "{59ba2fbb-24cb-4c02-a4c4-8294569d54f1}"
Private Const IID_ILauncherStatics3 As String = "{234261a8-9db3-4683-aa42-dc6f51d33847}"
Private Const IID_ILauncherStatics4 As String = "{b9ec819f-b5a5-41c6-b3b3-dd1b3178bcf2}"
Private Const IID_ILauncherStatics5 As String = "{5b24ef84-d895-5fea-9153-1ac49aed9ba9}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' ILauncherStatics
    ILauncherStatics_LaunchFileAsync = 6
    ILauncherStatics_LaunchFileWithOptionsAsync = 7
    ILauncherStatics_LaunchUriAsync = 8
    ILauncherStatics_LaunchUriWithOptionsAsync = 9
                    
    ' ILauncherStatics2
'    ILauncherStatics2_LaunchUriForResultsAsync = 6
'    ILauncherStatics2_LaunchUriForResultsWithDataAsync = 7
'    ILauncherStatics2_LaunchUriWithDataAsync = 8
'    ILauncherStatics2_QueryUriSupportAsync = 9
'    ILauncherStatics2_QueryUriSupportWithPackageFamilyNameAsync = 10
'    ILauncherStatics2_QueryFileSupportAsync = 11
'    ILauncherStatics2_QueryFileSupportWithPackageFamilyNameAsync = 12
'    ILauncherStatics2_FindUriSchemeHandlersAsync = 13
'    ILauncherStatics2_FindUriSchemeHandlersWithLaunchUriTypeAsync = 14
'    ILauncherStatics2_FindFileHandlersAsync = 15
                    
    ' ILauncherStatics3
    ILauncherStatics3_LaunchFolderAsync = 6
    ILauncherStatics3_LaunchFolderWithOptionsAsync = 7
                    
    ' ILauncherStatics4
'    ILauncherStatics4_QueryAppUriSupportAsync = 6
'    ILauncherStatics4_QueryAppUriSupportWithPackageFamilyNameAsync = 7
'    ILauncherStatics4_FindAppUriHandlersAsync = 8
'    ILauncherStatics4_LaunchUriForUserAsync = 9
'    ILauncherStatics4_LaunchUriWithOptionsForUserAsync = 10
'    ILauncherStatics4_LaunchUriWithDataForUserAsync = 11
'    ILauncherStatics4_LaunchUriForResultsForUserAsync = 12
'    ILauncherStatics4_LaunchUriForResultsWithDataForUserAsync = 13
                    
    ' ILauncherStatics5
    ILauncherStatics5_LaunchFolderPathAsync = 6
    ILauncherStatics5_LaunchFolderPathWithOptionsAsync = 7
'    ILauncherStatics5_LaunchFolderPathForUserAsync = 8
'    ILauncherStatics5_LaunchFolderPathWithOptionsForUserAsync = 9
                    
End Enum

' ----==== Variablen ====----
Private m_pILauncherStatics As Long
Private m_pILauncherStatics2 As Long
Private m_pILauncherStatics3 As Long
Private m_pILauncherStatics4 As Long
Private m_pILauncherStatics5 As Long

' ----==== Class ====----
Private Sub Class_Initialize()
    If GetActivationFactory(WindowsSystemLauncher, _
                            IID_ILauncherStatics, _
                            m_pILauncherStatics) Then
        Call QueryIfc(m_pILauncherStatics, IID_ILauncherStatics2, m_pILauncherStatics2)
        Call QueryIfc(m_pILauncherStatics, IID_ILauncherStatics3, m_pILauncherStatics3)
        Call QueryIfc(m_pILauncherStatics, IID_ILauncherStatics4, m_pILauncherStatics4)
        Call QueryIfc(m_pILauncherStatics, IID_ILauncherStatics5, m_pILauncherStatics5)
    End If
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pILauncherStatics5)
    Call ReleaseIfc(m_pILauncherStatics4)
    Call ReleaseIfc(m_pILauncherStatics3)
    Call ReleaseIfc(m_pILauncherStatics2)
    Call ReleaseIfc(m_pILauncherStatics)
End Sub

' ----==== Properties ====----
Public Property Get ILauncherStatics() As Long
    ILauncherStatics = m_pILauncherStatics
End Property

' ----==== Functions ====----
' ILauncherStatics
Public Function LaunchFileAsync(ByVal file As clsStorageFile) As Boolean
    Dim Ret As Boolean
    If m_pILauncherStatics <> 0& And _
       file.IStorageFile <> 0& Then
        Dim operation As Long
        If Invoke(m_pILauncherStatics, _
                  ILauncherStatics_LaunchFileAsync, _
                  file.IStorageFile, _
                  VarPtr(operation)) = S_OK Then
            If Await(operation) Then
                Ret = CBool(operation)
            End If
        End If
    End If
    LaunchFileAsync = Ret
End Function

Public Function LaunchFileWithOptionsAsync(ByVal file As clsStorageFile, _
                                           ByVal options As clsLauncherOptions) As Boolean
    Dim Ret As Boolean
    If m_pILauncherStatics <> 0& And _
       file.IStorageFile <> 0& And _
       options.ILauncherOptions <> 0& Then
        Dim operation As Long
        If Invoke(m_pILauncherStatics, _
                  ILauncherStatics_LaunchFileWithOptionsAsync, _
                  file.IStorageFile, _
                  options.ILauncherOptions, _
                  VarPtr(operation)) = S_OK Then
            If Await(operation) Then
                Ret = CBool(operation)
            End If
        End If
    End If
    LaunchFileWithOptionsAsync = Ret
End Function

Public Function LaunchUriAsync(ByVal uri As clsUriRuntimeClass) As Boolean
    Dim Ret As Boolean
    If m_pILauncherStatics <> 0& And _
       uri.IUriRuntimeClass <> 0& Then
        Dim operation As Long
        If Invoke(m_pILauncherStatics, _
                  ILauncherStatics_LaunchUriAsync, _
                  uri.IUriRuntimeClass, _
                  VarPtr(operation)) = S_OK Then
            If Await(operation) Then
                Ret = CBool(operation)
            End If
        End If
    End If
    LaunchUriAsync = Ret
End Function

Public Function LaunchUriWithOptionsAsync(ByVal uri As clsUriRuntimeClass, _
                                          ByVal options As clsLauncherOptions) As Boolean
    Dim Ret As Boolean
    If m_pILauncherStatics <> 0& And _
       uri.IUriRuntimeClass <> 0& And _
       options.ILauncherOptions <> 0& Then
        Dim operation As Long
        If Invoke(m_pILauncherStatics, _
                  ILauncherStatics_LaunchUriWithOptionsAsync, _
                  uri.IUriRuntimeClass, _
                  options.ILauncherOptions, _
                  VarPtr(operation)) = S_OK Then
            If Await(operation) Then
                Ret = CBool(operation)
            End If
        End If
    End If
    LaunchUriWithOptionsAsync = Ret
End Function
                    
' ILauncherStatics2
'    ILauncherStatics2_LaunchUriForResultsAsync = 6
'    ILauncherStatics2_LaunchUriForResultsWithDataAsync = 7
'    ILauncherStatics2_LaunchUriWithDataAsync = 8
'    ILauncherStatics2_QueryUriSupportAsync = 9
'    ILauncherStatics2_QueryUriSupportWithPackageFamilyNameAsync = 10
'    ILauncherStatics2_QueryFileSupportAsync = 11
'    ILauncherStatics2_QueryFileSupportWithPackageFamilyNameAsync = 12
'    ILauncherStatics2_FindUriSchemeHandlersAsync = 13
'    ILauncherStatics2_FindUriSchemeHandlersWithLaunchUriTypeAsync = 14
'    ILauncherStatics2_FindFileHandlersAsync = 15
                    
' ILauncherStatics3
Public Function LaunchFolderAsync(ByVal folder As clsStorageFolder) As Boolean
    Dim Ret As Boolean
    If m_pILauncherStatics3 <> 0& And _
       folder.IStorageFolder <> 0& Then
        Dim operation As Long
        If Invoke(m_pILauncherStatics3, _
                  ILauncherStatics3_LaunchFolderAsync, _
                  folder.IStorageFolder, _
                  VarPtr(operation)) = S_OK Then
            If Await(operation) Then
                Ret = CBool(operation)
            End If
        End If
    End If
    LaunchFolderAsync = Ret
End Function

Public Function LaunchFolderWithOptionsAsync(ByVal folder As clsStorageFolder, _
                                             ByVal options As clsFolderLauncherOptions) As Boolean
    Dim Ret As Boolean
    If m_pILauncherStatics3 <> 0& And _
       folder.IStorageFolder <> 0& And _
       options.IFolderLauncherOptions <> 0& Then
        Dim operation As Long
        If Invoke(m_pILauncherStatics3, _
                  ILauncherStatics3_LaunchFolderWithOptionsAsync, _
                  folder.IStorageFolder, _
                  options.IFolderLauncherOptions, _
                  VarPtr(operation)) = S_OK Then
            If Await(operation) Then
                Ret = CBool(operation)
            End If
        End If
    End If
    LaunchFolderWithOptionsAsync = Ret
End Function
                    
' ILauncherStatics4
'    ILauncherStatics4_QueryAppUriSupportAsync = 6
'    ILauncherStatics4_QueryAppUriSupportWithPackageFamilyNameAsync = 7
'    ILauncherStatics4_FindAppUriHandlersAsync = 8
'    ILauncherStatics4_LaunchUriForUserAsync = 9
'    ILauncherStatics4_LaunchUriWithOptionsForUserAsync = 10
'    ILauncherStatics4_LaunchUriWithDataForUserAsync = 11
'    ILauncherStatics4_LaunchUriForResultsForUserAsync = 12
'    ILauncherStatics4_LaunchUriForResultsWithDataForUserAsync = 13
                    
' ILauncherStatics5
Public Function LaunchFolderPathAsync(ByVal path As String) As Boolean
    Dim Ret As Boolean
    If m_pILauncherStatics5 <> 0& And _
       path <> vbNullString Then
        Dim hString As Long
        hString = CreateWindowsString(path)
        If hString <> 0& Then
            Dim operation As Long
            If Invoke(m_pILauncherStatics5, _
                      ILauncherStatics5_LaunchFolderPathAsync, _
                      hString, _
                      VarPtr(operation)) = S_OK Then
                If Await(operation) Then
                    Ret = CBool(operation)
                End If
            End If
            Call DeleteWindowsString(hString)
        End If
    End If
    LaunchFolderPathAsync = Ret
End Function

Public Function LaunchFolderPathWithOptionsAsync(ByVal path As String, _
                                                 ByVal options As clsFolderLauncherOptions) As Boolean
    Dim Ret As Boolean
    If m_pILauncherStatics5 <> 0& And _
       path <> vbNullString And _
       options.IFolderLauncherOptions <> 0& Then
        Dim hString As Long
        hString = CreateWindowsString(path)
        If hString <> 0& Then
            Dim operation As Long
            If Invoke(m_pILauncherStatics5, _
                      ILauncherStatics5_LaunchFolderPathWithOptionsAsync, _
                      hString, _
                      options.IFolderLauncherOptions, _
                      VarPtr(operation)) = S_OK Then
                If Await(operation) Then
                    Ret = CBool(operation)
                End If
            End If
            Call DeleteWindowsString(hString)
        End If
    End If
    LaunchFolderPathWithOptionsAsync = Ret
End Function

'    ILauncherStatics5_LaunchFolderPathForUserAsync = 8
'    ILauncherStatics5_LaunchFolderPathWithOptionsForUserAsync = 9

' ----==== Invoke Interface ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function

