VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsStorageFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const WindowsStorageStorageFile As String = "Windows.Storage.StorageFile"
Private Const IID_IStorageFile As String = "{fa3f6186-4214-428c-a64c-14c9ac7315ea}"
Private Const IID_IStorageFileStatics As String = "{5984c710-daf2-43c8-8bb4-a4d3eacfd03f}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IStorageFileStatics
    IStorageFileStatics_GetFileFromPathAsync = 6

End Enum

' ----==== Variablen ====----
Private m_pIStorageFile As Long
Private m_pIStorageFileStatics As Long

' ----==== Class ====----
Private Sub Class_Initialize()
    If GetActivationFactory(WindowsStorageStorageFile, _
                            IID_IStorageFileStatics, _
                            m_pIStorageFileStatics) Then
    End If
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIStorageFile)
    Call ReleaseIfc(m_pIStorageFileStatics)
End Sub

' ----==== Properties ====----
Public Property Get IStorageFile() As Long
    IStorageFile = m_pIStorageFile
End Property

Public Property Let IStorageFile(ByVal pIStorageFile As Long)
    Call ReleaseIfc(m_pIStorageFile)
    m_pIStorageFile = pIStorageFile
End Property

' ----==== Functions ====----
Public Function GetFileFromPathAsync(ByVal Path As String) As Boolean
    Dim Ret As Boolean
    If m_pIStorageFileStatics <> 0& Then
        Dim hString As Long
        hString = CreateWindowsString(Path)
        If hString <> 0& Then
            Dim pIStorageFile As Long
            If Invoke(m_pIStorageFileStatics, _
                      IStorageFileStatics_GetFileFromPathAsync, _
                      hString, VarPtr(pIStorageFile)) = S_OK Then
                If Await(pIStorageFile) Then
                    Me.IStorageFile = pIStorageFile
                    Ret = True
                End If
            End If
            Call DeleteWindowsString(hString)
        End If
    End If
    GetFileFromPathAsync = Ret
End Function

' ----==== Invoke Interface ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function

