VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsStorageFolder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const WindowsStorageStorageFolder As String = "Windows.Storage.StorageFolder"
Private Const IID_IStorageFolder As String = "{72d1cb78-b3ef-4f75-a80b-6fd9dae2944b}"
Private Const IID_IStorageFolderStatics As String = "{08f327ff-85d5-48b9-aee9-28511e339f9f}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IStorageFolderStatics
    IStorageFolderStatics_GetFolderFromPathAsync = 6

End Enum

' ----==== Variablen ====----
Private m_pIStorageFolder As Long
Private m_pIStorageFolderStatics As Long

' ----==== Class ====----
Private Sub Class_Initialize()
    If GetActivationFactory(WindowsStorageStorageFolder, _
                            IID_IStorageFolderStatics, _
                            m_pIStorageFolderStatics) Then
    End If
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIStorageFolder)
    Call ReleaseIfc(m_pIStorageFolderStatics)
End Sub

' ----==== Properties ====----
Public Property Get IStorageFolder() As Long
    IStorageFolder = m_pIStorageFolder
End Property

Public Property Let IStorageFolder(ByVal pIStorageFolder As Long)
    Call ReleaseIfc(m_pIStorageFolder)
    m_pIStorageFolder = pIStorageFolder
End Property

' ----==== Functions ====----
Public Function GetFolderFromPathAsync(ByVal Path As String) As Boolean
    Dim Ret As Boolean
    If m_pIStorageFolderStatics <> 0& Then
        Dim hString As Long
        hString = CreateWindowsString(Path)
        If hString <> 0& Then
            Dim pIStorageFolder As Long
            If Invoke(m_pIStorageFolderStatics, _
                      IStorageFolderStatics_GetFolderFromPathAsync, _
                      hString, VarPtr(pIStorageFolder)) = S_OK Then
                If Await(pIStorageFolder) Then
                    Me.IStorageFolder = pIStorageFolder
                    Ret = True
                End If
            End If
            Call DeleteWindowsString(hString)
        End If
    End If
    GetFolderFromPathAsync = Ret
End Function

' ----==== Invoke Interface ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function

